Imports System.Net
Imports System.Net.Security
Imports System.Security.Cryptography.X509Certificates

Public Class ACHPOC

  Private SSL_Certificate_Validation_Errors As String

  Private Sub btnACHSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnACHSend.Click

    txtResults.Clear()

    ' Reference:
    ' http://msdn.microsoft.com/en-us/magazine/cc163454.aspx#S7
    ' http://social.msdn.microsoft.com/Forums/en-US/netfxnetcom/thread/8bcf6b40-619e-4151-9885-22242b7e95b0

    Const TEST_SSL_PORT As Integer = 6050
    Const TEST_SSL_SERVER As String = "www.paymentsgateway.net"

    Dim myTCPClient As New Sockets.TcpClient
    Dim mySSLStream As SslStream = Nothing

    Try

      'Get data to send
      Dim testData() As String = {"pg_merchant_id=100000", _
                                  "pg_password=not_a_real_password", _
                                  "pg_transaction_type=20", _
                                  "pg_total_amount=1.00", _
                                  "Ecom_BillTo_Postal_Name_First=John", _
                                  "Ecom_BillTo_Postal_Name_Last=Smith", _
                                  "Ecom_Payment_Check_AccounT_Type=S", _
                                  "Ecom_Payment_Check_Account=1234567812345678", _
                                  "Ecom_Payment_Check_TRN=021000021", _
                                  "endofdata"}

      Dim achMessage As New System.Text.StringBuilder
      For x As Integer = 0 To testData.Length - 1
        achMessage.AppendLine(testData(x))
      Next

      'Connect TCP Client
      myTCPClient.Connect(TEST_SSL_SERVER, TEST_SSL_PORT)

      'Create SSL Stream
      mySSLStream = New SslStream(myTCPClient.GetStream, False, _
        New RemoteCertificateValidationCallback(AddressOf SSLCertificateCallbackValidation))

      mySSLStream.AuthenticateAsClient(TEST_SSL_SERVER)

      Dim sendBuffer() As Byte = System.Text.Encoding.ASCII.GetBytes(achMessage.ToString)
      Dim receiveBuffer(1023) As Byte

      mySSLStream.Write(sendBuffer)
      mySSLStream.Flush()
      mySSLStream.Read(receiveBuffer, 0, 1024)

      txtResults.Text += System.Text.Encoding.ASCII.GetChars(receiveBuffer)

    Catch ex As Exception
      txtResults.Text += Environment.NewLine & ex.ToString & Environment.NewLine & SSL_Certificate_Validation_Errors

    Finally
      If mySSLStream IsNot Nothing Then
        mySSLStream.Close()
      End If
    End Try

  End Sub

  ''' <summary>
  ''' Validates the SSL Certificate on the Server
  ''' </summary>
  ''' <returns></returns>
  ''' <remarks></remarks>
  Private Function SSLCertificateCallbackValidation( _
    ByVal Sender As Object, ByVal Certificate As X509Certificate, _
    ByVal Chain As X509Chain, ByVal SSLPolicyErrors As SslPolicyErrors) As Boolean

    Try

      If SSLPolicyErrors <> Security.SslPolicyErrors.None Then
        SSL_Certificate_Validation_Errors = SSLPolicyErrors.ToString
        Return False
      Else
        SSL_Certificate_Validation_Errors = Nothing
        Return True
      End If

    Catch ex As Exception
      txtResults.Text += Environment.NewLine & ex.ToString & Environment.NewLine
      Return False
    End Try

  End Function

End Class
